CREATE TABLE IF NOT EXISTS `CFG_ServerTeamRoleIdsHistory`
(
    `Id`    BIGINT(20)  NOT NULL,
    `RoleId` BIGINT NOT NULL,
    `TeamMemberType` ENUM('Moderator', 'Admin') NOT NULL,
    `ServerId` BIGINT NOT NULL,
    `Deleted` BOOL DEFAULT FALSE,
    `DateFrom` DATETIME(6) NOT NULL,
    `DateTo` DATETIME(6) NOT NULL
);

DROP TRIGGER IF EXISTS `TR_CFG_ServerTeamRoleIdsUpdate`;

CREATE TRIGGER `TR_CFG_ServerTeamRoleIdsUpdate`
    AFTER UPDATE
    ON `CFG_ServerTeamRoleIds`
    FOR EACH ROW
BEGIN
    INSERT INTO `CFG_ServerTeamRoleIdsHistory` (
        `Id`,
        `RoleId`,
        `TeamMemberType`,
        `ServerId`,
        `DateFrom`,
        `DateTo`
    )
    VALUES (
        OLD.Id,
        OLD.RoleId,
        OLD.TeamMemberType,
        OLD.ServerId,
        OLD.LastModifiedAt,
        CURRENT_TIMESTAMP(6)
    );
END;

DROP TRIGGER IF EXISTS `TR_CFG_ServerTeamRoleIdsDelete`;

CREATE TRIGGER `TR_CFG_ServerTeamRoleIdsDelete`
    AFTER DELETE
    ON `CFG_ServerTeamRoleIds`
    FOR EACH ROW
BEGIN
    INSERT INTO `CFG_ServerTeamRoleIdsHistory` (
        `Id`,
        `RoleId`,
        `TeamMemberType`,
        `ServerId`,
        `Deleted`,
        `DateFrom`,
        `DateTo`
    )
    VALUES (
        OLD.Id,
        OLD.RoleId,
        OLD.TeamMemberType,
        OLD.ServerId,
        TRUE,
        OLD.LastModifiedAt,
        CURRENT_TIMESTAMP(6)
    );
END;