export interface Column {
  key: string;
  name: string;
}

export class ComponentWithTable {
  private _hiddenColumns: Column[] = [];
  set hiddenColumns(value: Column[]) {
    this._hiddenColumns = value;
    localStorage.setItem("hiddenColumns", JSON.stringify(value));
  }

  get hiddenColumns(): Column[] {
    return this._hiddenColumns;
  }

  public name: string = "";
  public columns: Column[] = [];
  public isEditingNew: boolean = false;

  public callback = (data: any[], isNew: boolean) => {
    this.save(data, isNew);
  };
  public validator: (oldElement: any, newElement: any) => boolean = (oldElement: any, newElement: any) => {
    return true;
  };

  constructor(
    name: string,
    columns: string[],
    validator?: (oldElement: any, newElement: any) => boolean
  ) {
    this.name = name;
    this.columns = columns.map(column => {
      return { key: this.getKey(column), name: column };
    });
    let hiddenColumns = localStorage.getItem("hiddenColumns");
    if (!hiddenColumns) {
      localStorage.setItem("hiddenColumns", JSON.stringify([{}]));
      hiddenColumns = localStorage.getItem("hiddenColumns") ?? JSON.stringify([{}]);
    }
    this._hiddenColumns = JSON.parse(hiddenColumns);
    if (validator) {
      this.validator = validator;
    }
  }

  private getKey(column: string): string {
    return `${this.name}_${column}`;
  }

  public isColumnVisible(column: string): boolean {
    return !this._hiddenColumns.map(column => column.key).includes(this.getKey(column));
  }

  public onRowEditSave(newLevel: any, index: number) {
  }

  public save(data: any[], isNew: boolean) {
    for (let i = 0; i < data.length; i++) {
      this.isEditingNew = isNew;
      this.onRowEditSave(data[i], i);
    }
  }
}
