import { CommonModule } from "@angular/common";
import { HttpClientModule } from "@angular/common/http";
import { NgModule } from "@angular/core";
import { FormsModule, ReactiveFormsModule } from "@angular/forms";
import { TranslateModule } from "@ngx-translate/core";
import { ButtonModule } from "primeng/button";
import { CheckboxModule } from "primeng/checkbox";
import { ConfirmDialogModule } from "primeng/confirmdialog";
import { DialogModule } from "primeng/dialog";
import { DropdownModule } from "primeng/dropdown";
import { DynamicDialogModule } from "primeng/dynamicdialog";
import { InputTextModule } from "primeng/inputtext";
import { MenuModule } from "primeng/menu";
import { PasswordModule } from "primeng/password";
import { ProgressSpinnerModule } from "primeng/progressspinner";
import { SortableColumn, TableModule } from "primeng/table";
import { ToastModule } from "primeng/toast";
import { AuthRolePipe } from "./pipes/auth-role.pipe";
import { IpAddressPipe } from "./pipes/ip-address.pipe";
import { BoolPipe } from "./pipes/bool.pipe";
import { PanelMenuModule } from "primeng/panelmenu";
import { PanelModule } from "primeng/panel";
import { InputNumberModule } from "primeng/inputnumber";
import { ImageModule } from "primeng/image";
import { SidebarModule } from "primeng/sidebar";
import { HistoryBtnComponent } from "./components/history-btn/history-btn.component";
import { DataViewModule, DataViewLayoutOptions } from "primeng/dataview";
import { ConfigListComponent } from "./components/config-list/config-list.component";
import { MultiSelectModule } from "primeng/multiselect";
import { HideableColumnComponent } from './components/hideable-column/hideable-column.component';
import { HideableHeaderComponent } from './components/hideable-header/hideable-header.component';
import { MultiSelectColumnsComponent } from './base/multi-select-columns/multi-select-columns.component';
import { FeatureFlagListComponent } from './components/feature-flag-list/feature-flag-list.component';
import { InputSwitchModule } from "primeng/inputswitch";
import { CalendarModule } from "primeng/calendar";
import { DataImportAndExportComponent } from './components/data-import-and-export/data-import-and-export.component';
import { FileUploadModule } from "primeng/fileupload";


const PrimeNGModules = [
  ButtonModule,
  PasswordModule,
  MenuModule,
  DialogModule,
  ProgressSpinnerModule,
  HttpClientModule,
  FormsModule,
  ReactiveFormsModule,
  ToastModule,
  ConfirmDialogModule,
  TableModule,
  InputTextModule,
  CheckboxModule,
  DropdownModule,
  TranslateModule,
  DynamicDialogModule,
  PanelMenuModule,
  PanelModule,
  InputNumberModule,
  ImageModule,
  SidebarModule,
  DataViewModule,
  MultiSelectModule,
  InputSwitchModule,
  CalendarModule,
  FileUploadModule,
]

@NgModule({
  declarations: [
    AuthRolePipe,
    IpAddressPipe,
    BoolPipe,
    HistoryBtnComponent,
    ConfigListComponent,
    HideableColumnComponent,
    HideableHeaderComponent,
    MultiSelectColumnsComponent,
    FeatureFlagListComponent,
    DataImportAndExportComponent,
  ],
  imports: [
    CommonModule,
    ...PrimeNGModules
  ],
  exports: [
    ...PrimeNGModules,
    AuthRolePipe,
    IpAddressPipe,
    BoolPipe,
    HistoryBtnComponent,
    DataViewLayoutOptions,
    ConfigListComponent,
    HideableColumnComponent,
    HideableHeaderComponent,
    MultiSelectColumnsComponent,
    FeatureFlagListComponent,
    DataImportAndExportComponent
  ]
})
export class SharedModule {
}
